<template lang="html">
    <div id="payments">
        <h3 class="text-center">{{ this.$store.getters.getOperator.title }}</h3><hr>

        <form id="paymentsForm" @submit.prevent="submitForm">
            <div class="form-group">
                <label for="phone">Номер телефона</label>
                <input type="text" name="phone" class="form-control" v-model="phone" v-mask="'+7 (###) ##-##-##'" placeholder="+7 (000) 00-00-00">
                <small id="phoneHelp" class="form-text text-muted">Введите номер телефона</small>
            </div>

            <div class="form-group">
                <label for="money">Сумма для пополнения</label>
                <money type="text" name="money" class="form-control" v-model="money" v-bind="moneyMask" placeholder="1 000"></money>
                <small id="moneyHelp" class="form-text text-muted">Минимальная сумма оплаты - 1 руб, максимальная - 1000 руб</small>
            </div>

            <input type="submit" class="btn btn-success btn-block btn-md" value="Подтвердить" :disabled="validated == 0">
            <router-link to="/" class="btn btn-warning btn-block btn-md">Отмена</router-link>
        </form>

        <modal v-if="showModal" @close="showModal = false">
            <h3 slot="header" v-if="!modalStatus" class="text-primary">
                Ошибка!
            </h3>
            <p slot="body" v-if="!modalStatus">
                Возникла ошибка при выполнении операции, пожалуйста повторите попытку позже
            </p>
            <h3 slot="header" v-if="modalStatus" class="text-sucess">
                Успех!
            </h3>
            <p slot="body" v-if="modalStatus">
                Ваш платеж был подтвержден
            </p>
            <router-link slot="footer" v-if="modalStatus" to="/" class="btn btn-success modal-default-button">ОК</router-link>
        </modal>
    </div>
</template>

<script>
    import {HTTP} from '../http-common';
    import {mask} from 'vue-the-mask';
    import {Money} from 'v-money';
    import Modal from './Modal.vue';
    export default {
        name: 'payments',
        props: ['id'],
        components: {Money, Modal},
        data () {
            return {
                validated: !true,
                showModal: false,
                modalStatus: false,
                phone: '',
                money: 10,
                moneyMask: {
                    thousands: ' ',
                    precision: 0,
                    // min: 1,
                    max: 1000,
                }
            }
        },
        directives: {
            mask:  mask
        },
        methods: {
            submitForm: function(e) {
                HTTP.post("/payment", {})
                    .then((response) => {
                        this.showModal   = true;
                        this.modalStatus = response.data.success;
                    });
            },
            checkForm: function(e) {
                var phone = (this.phone.length == 17);
                var momey = (this.money >= 1 && this.money <= 1000);

                this.validated = phone && momey;
            },
        },
        watch: {
            phone: function (val, oldVal) {
                this.checkForm();
            },
            money: function (val, oldVal) {
                this.checkForm();
            }
        }
    }
</script>

<style lang="scss" scoped>
    .btn-md {
        padding-top:    1rem;
        padding-bottom: 1rem;
    }
</style>
